#!/usr/bin/perl

use Linux::Inotify2;
use WWW::Mechanize::Firefox;
my $mech = WWW::Mechanize::Firefox->new();

my $inotify = new Linux::Inotify2
  or die "unable to create new inotify object: $!";


$org_files = `find /home/r/proj -name "*.org" -print0`;
@org_files = split /\0/, $org_files;

#@org_files =  glob("./org/*.org");

for $file(@org_files){print "$file\n";}
$ignore_next = 0;
$last_page = "";

foreach(@org_files){
# add watchers
$inotify->watch ($_, IN_MODIFY, sub 
{
    print ("IGNORE : $ignore_next\n");
    # ok, for some reason this gets called exactly 
    # twice every time the file is saved from emacs.
    # so ignore every other invocation.
    if ($ignore_next) {
	$ignore_next = 0;
	return;
    }
    $ignore_next = 1;

    my $e = shift;
    my $name = $e->fullname;
    print "$name was modified\n" if $e->IN_MODIFY;
    $output = `weave $name`;
    $path = `readlink -f $name`;
    $path =~ s|/home/r/proj|http://aurellem.localhost|;
    $path =~ s|org|html|g;
    if ($last_page eq $path){
	print "reloading current page : $path\n";
	$mech->reload();
    }
    else {
	print "moving to new page : $path\n";
	$last_page = $path;
	$mech->get($path);
    }
});
}


# manual event loop
1 while $inotify->poll;
